package minischeme

abstract class Opcode(val name: String) {
  override def toString(): String = name
}

abstract class OpcodeRRR(name: String) extends Opcode(name)
case object ADD extends OpcodeRRR("ADD")
case object SUB extends OpcodeRRR("SUB")
case object MUL extends OpcodeRRR("MUL")
case object DIV extends OpcodeRRR("DIV")
case object MOD extends OpcodeRRR("MOD")

case object ISLT extends OpcodeRRR("ISLT")
case object ISLE extends OpcodeRRR("ISLE")
case object ISEQ extends OpcodeRRR("ISEQ")

case object LOAD extends OpcodeRRR("LOAD")
case object STOR extends OpcodeRRR("STOR")

abstract class OpcodeRR(name: String) extends Opcode(name)
case object JMPZ  extends OpcodeRR("JMPZ")
case object ALOC extends OpcodeRR("ALOC")

case object LINT extends Opcode("LINT")

abstract class OpcodeR(name: String) extends Opcode(name)
case object RCHR extends OpcodeR("RCHR")
case object PCHR extends OpcodeR("PCHR")

case object HALT extends Opcode("HALT")
