package minischeme

object Primitives {
  private var table = new scala.collection.mutable.HashMap[String,Int]()

  table += "vector-set!" -> 3
  for (n <- List("+", "-", "*", "/", "%", "=", "<", "<=", "vector-ref"))
    table += n -> 2
  table += "print-char" -> 1
  table += "read-char" -> 0
  table += "vector" -> -1

  def is(t: Tree): Boolean =
    t.symbol != null && t.symbol.kind == PrimitiveKind

  val names: List[String] =
    table.keys.toList

  def arity(name: String): Int =
    table(name)
}
